package lim;

public class InverseDistanceWeighting {

	public double[] x, y, f;

	public InverseDistanceWeighting() {
		x = new double[6];
		y = new double[6];
		f = new double[6];
	}

	// Algoritmo InverseDistanceWeighting
	// http://en.wikipedia.org/wiki/Inverse_distance_weighting
	public double getValue(double xP, double yP) {
		double z = 0.0, w = 0.0;
		for (int i = 0; i < 6; i++) {
			double d2 = (xP - x[i]) * (xP - x[i]) + (yP - y[i]) * (yP - y[i]);
			if (d2 == 0.0)
				return f[i];
			else {
				z += f[i] / d2;
				w += 1.0 / d2;
			}
		}
		return z / w;
	}
}
